import 'package:flutter/cupertino.dart';
import 'package:hive/hive.dart';
import 'package:osam/src/persist/persist_repository.dart';

import '../../osam.dart';

abstract class Persist<AS, US> {
  factory Persist({@required String appName}) =>
      PersistRepository<AS, US>(appName: appName);

  Future<void> init();

  Future<void> save({AS state, US uiState, int version});

  AS get appState;

  US get uiState;

  Future<int> get version;

  Future<void> delete();

  Future<void> deleteFromStorage();

  bool get isPersistEnabled;
}
